<template>
  <!--SI LOS DATOS DE LA TABLA NO COINCIDEN IR A LA LÍNEA 79 (HEADERS) Y CAMBIAR EL VALOR DE 'VALUE' POR LA CABECERA QUE TENGAN LOS DATOS AL SER RECIBIDOS.
  TODOS DEBEN ESTAR EN UNA MISMA TABLA, INCLUYENDO LAS IMÁGENES'-->
  <v-card>
    <v-card-title>
      <v-text-field
        v-model="search"
        append-icon="fa-search"
        label="Buscar"
        single-line
        hide-details
      ></v-text-field>
      <v-switch v-model="open" label="Registro de invitaciones"></v-switch>
      <router-link :to="{ name: 'FinalInv' }" tag="button" style="color: #FFF; background-color:#1B396A; padding:3px; border-radius:7px">
      Lista de graduados
    </router-link>
    </v-card-title>
    <v-row justify="center">
      <v-dialog v-model="dialogConf" persistent max-width="350">
        <v-card>
          <v-card-title class="headline">¿Rechazar solicitud?</v-card-title>
          <v-card-text>Esta acción no es reversible. Se notificará al solicitante vía correo electrónico.</v-card-text>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="grey darken-1" text @click="dialogConf = false">Cancelar</v-btn>
            <v-btn color="red darken-1" text @click="confirmDelete(editedItem)">Aceptar</v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </v-row>
    <v-data-table :headers="headers" :items="data" :search="search" class="elevation-1">
      <template v-slot:top>
        <v-toolbar flat color="white">
          <v-dialog v-model="dialog" max-width="95vw">
            <v-card>
              <v-img :src="editedItem.img"></v-img>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="grey darken-1" text @click="dialog = false">Aceptar</v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:item.action="{ item }">
        <v-tooltip top>
          <template v-slot:activator="{ on }">
            <v-icon @click="editItem(item)" v-on="on">mdi-image-search</v-icon>
          </template>
          <span>Ver comprobante de pago</span>
        </v-tooltip>

        <v-tooltip top>
          <template v-slot:activator="{ on }">
            <v-icon style="color: green" v-on="on" @click="checkItem(item)">mdi-check</v-icon>
          </template>
          <span>Aceptar</span>
        </v-tooltip>


        <v-tooltip top>
          <template v-slot:activator="{ on }">
            <v-icon style="color: red" v-on="on" @click="deleteItem(item)">mdi-cancel</v-icon>
          </template>
          <span>Rechazar</span>
        </v-tooltip>
      </template>
    </v-data-table>
    <br />
    <br />
  </v-card>
</template>

<script>
import firebase from "../firebase/firebase.js";
export default {
  data: () => ({
    open: true,
    dialog: false,
    dialogConf: false,
    search: "",
    headers: [
      {
        text: "Número de control",
        align: "center",
        sortable: true,
        value: "control"
      },
      {
        text: "Nombre",
        align: "center",
        sortable: true,
        value: "name"
      },
      {
        text: "Carrera",
        align: "center",
        sortable: true,
        value: "carreer"
      },
      {
        text: "Correo",
        align: "center",
        sortable: true,
        value: "email"
      },
      { text: "Acciones", value: "action", sortable: false }
    ],
    data: [],
    editedIndex: -1,
    editedItem: {
      control: 0,
      name: "",
      carreer: "",
      gen: 0
    },
    defaultItem: {
      control: 0,
      name: "",
      carreer: "",
      gen: 0
    }
  }),
  computed: {
    formTitle() {
      return this.editedIndex === -1 ? "New Item" : "Edit Item";
    }
  },
  watch: {
    open(val) {
      if (val === false || val === true) {
        var db = firebase.firestore();
        db.collection("config")
          .doc(`0vFBCMlgVFa8QYiVuFuU`)
          .set({
            open: val
          });
      }
    },
    dialog(val) {
      val || this.close();
    }
  },

  methods: {
    async images(id) {
      var storage = firebase.storage();
      var pathReference = await storage.ref(id).getDownloadURL();
      return pathReference;
    },
    initialize() {
      this.data = [];
    },

    editItem(item) {
      this.editedIndex = this.data.indexOf(item);
      this.editedItem = Object.assign({}, item);
      this.dialog = true;
    },

    deleteItem(item) {
      this.editedIndex = this.data.indexOf(item);
      this.editedItem = Object.assign({}, item);
      this.dialogConf = true;
    },
    confirmDelete(item) {
      var db = firebase.firestore();
      this.dialog = false;
      this.dialogConf = false;
      this.$swal("Listo", "Se ha aceptado la solicitud", "success");
      //INSERTAR CONSULTA PARA RECHAZAR SOLICITUDES. LOS DATOS ESTÁN EN EL ARREGLO 'item'. Si ocupan el número de control pos ponen item.control pa sacarlo
      db.collection("requests")
        .doc(`${item.id}`)
        .delete()
        .then(function() {
          console.log("Document successfully deleted!");
        })
        .catch(function(error) {
          console.error("Error removing document: ", error);
        });
      //ESTA WEA DEBE QUEDAR AL FINAL O DONDE SE CONFIRMA LA ACCIÓN EN LA BD
      this.$swal("Listo", "Se ha rechazado la solicitud", "success");
    },
    checkItem(item) {
      var careersMorning = ["CDVg1aIhaGYR4bxuWRUj", "8FQJ8J8aQpm1KMIoiJAv", "LU9ZlhJQgOnKzwC287Sw", "DKOVpU2GDuF5fGMGdCSb", "GAucYNOESXIH3WqfDfzL", "PZelh5COePfkwOvSTaOr", "ah4Vdvt2H7BVX9NVeOcP", "b22fd4h61Kj4EA7Zhi5v", "qFuJ9jjM7lxvwKbNiCH9", "tkknRbene9Bk52rRmSve", "ySAV93AHKWTbZpHyn6Nw", "zhZ7ZIUPyOaqG7Ym4DJK"];
      var careersAfternoon = ["16TZvPIc5XpDAn5e4KwR", "DSPrPl1ueUoFVjKCmWuf", "Ds6jhOFwYnrfLFV5yvlq", "FlYRFl9nyrz0Kl1Mam22", "Ngbj4MwaFwL1VCr66uAL", "PZscEfGJlQBRpNcXDWgR", "bHLf9OgOC5xK7iH0YWUb", "bid9LWZgQCqa2wTIz3yb", "cXtYa46Sa8aFUsv5dopU", "pCRdulfljhuvrhA39MNF", "q1WNq0v2CI21S3R67JhZ", "zAU1JXhVu2RuZvFMOqjk"];
      var db = firebase.firestore();
      //INSERTAR CONSULTA PARA ACEPTAR SOLICITUDES. LOS DATOS ESTÁN EN EL ARREGLO 'item'. Si ocupan el número de control pos ponen item.control pa sacarlo
      db.collection("requests")
        .doc(`${item.id}`)
        .set({
          accepted: 1,
          career: db.doc(`/careers/${item.career_id}`),
          control_number: `${item.control}`,
          email: `${item.email}`,
          end_year: `${item.endyear}`,
          lastname: `${item.lastname}`,
          name: `${item.name2}`,
          payment: `${item.payment}`,
          semester: `${item.semester}`,
          specialty: `${item.specialty}`,
          start_year: `${item.startyear}`
        });
        if(careersMorning.includes(`${item.career_id}`)){
        db.collection("invitations")
        .add({
          event: db.doc("/events/8elvQBrBI3bPCwAS5zTS"),
          request: db.doc(`/requests/${item.id}`)
        })
        .then(document => {
          console.log("Document successfully written!");
          const sendEmail = firebase.functions().httpsCallable("sendEmail");
          sendEmail({ invitation: document.id });
        })
        .catch(function(error) {
          console.error("Error writing document: ", error);
        });
      }
      if(careersAfternoon.includes(`${item.career_id}`)){
        db.collection("invitations")
        .add({
          event: db.doc("/events/NcHdKGHGgQBbSeCdZ57z"),
          request: db.doc(`/requests/${item.id}`)
        })
        .then(document => {
          console.log("Document successfully written!");
          const sendEmail = firebase.functions().httpsCallable("sendEmail");
          sendEmail({ invitation: document.id });
        })
        .catch(function(error) {
          console.error("Error writing document: ", error);
        });
      }
      
      //ESTA WEA DEBE QUEDAR AL FINAL O DONDE SE CONFIRMA LA ACCIÓN EN LA BD
      this.$swal("Listo", "Se ha aceptado la solicitud", "success");
    },

    close() {
      this.dialog = false;
      setTimeout(() => {
        this.editedItem = Object.assign({}, this.defaultItem);
        this.editedIndex = -1;
      }, 300);
    },

    save() {
      if (this.editedIndex > -1) {
        Object.assign(this.data[this.editedIndex], this.editedItem);
      } else {
        this.data.push(this.editedItem);
      }
      this.close();
    }
  },
  created() {
    var db = firebase.firestore();
    var storage = firebase.storage();

    db.collection("requests").onSnapshot(querySnapshot => {
      querySnapshot.forEach(async doc => {
        let career = await db
          .collection("careers")
          .doc(`${doc.data().career.id}`)
          .get();
        var images = await this.images(doc.data().payment);
        this.data.push({
          control: doc.data().control_number,
          name: doc.data().name + " " + doc.data().lastname,
          name2: doc.data().name,
          lastname: doc.data().lastname,
          carreer: career.data().name,
          career_id: career.id,
          payment: doc.data().payment,
          email: doc.data().email,
          endyear: doc.data().end_year,
          startyear: doc.data().start_year,
          semester: doc.data().semester,
          specialty: doc.data().specialty,
          img: images,
          id: doc.id,
          status: doc.data().accepted,
          gen: doc.data().email
        });
      });
      this.$store.commit("setList", this.data);
    });

    var db = firebase.firestore();
    db.collection("config")
      .doc(`0vFBCMlgVFa8QYiVuFuU`)
      .get()
      .then(snapshot => {
        this.open = snapshot.data();
      })
      .catch(error => {
        console.error("Error get config: ", error);
      });
      /* ********* CONSULTA PARA OBTENER A GRADUADOS PARA LISTARLOS ***************
      // Arrays con los id's de las carreras que se graduan en la mañana y en la tarde
      var careersMorning = ["CDVg1aIhaGYR4bxuWRUj", "8FQJ8J8aQpm1KMIoiJAv", "LU9ZlhJQgOnKzwC287Sw", "DKOVpU2GDuF5fGMGdCSb", "GAucYNOESXIH3WqfDfzL", "PZelh5COePfkwOvSTaOr", "ah4Vdvt2H7BVX9NVeOcP", "b22fd4h61Kj4EA7Zhi5v", "qFuJ9jjM7lxvwKbNiCH9", "tkknRbene9Bk52rRmSve", "ySAV93AHKWTbZpHyn6Nw", "zhZ7ZIUPyOaqG7Ym4DJK"];
      var careersAfternoon = ["16TZvPIc5XpDAn5e4KwR", "DSPrPl1ueUoFVjKCmWuf", "Ds6jhOFwYnrfLFV5yvlq", "FlYRFl9nyrz0Kl1Mam22", "Ngbj4MwaFwL1VCr66uAL", "PZscEfGJlQBRpNcXDWgR", "bHLf9OgOC5xK7iH0YWUb", "bid9LWZgQCqa2wTIz3yb", "cXtYa46Sa8aFUsv5dopU", "pCRdulfljhuvrhA39MNF", "q1WNq0v2CI21S3R67JhZ", "zAU1JXhVu2RuZvFMOqjk"];

      let morningReferences = [];
      let afternoonReferences = [];

      // Creación de referencias
      careersMorning.forEach(career => {
        const careerRef = db.collection('careers').doc(career);
        morningReferences.push(careerRef);
      });
      careersAfternoon.forEach(carreer => {
        const careerRef = db.collection('careers').doc(career);
        afternoonReferences.push(careerRef);
      });

      //Consultas a BD
      morningReferences.forEach(reference => {
        db.collection("requests")
        .where("career", "==", reference).where("accepted", "==", 1).get().then(
          result => { 
            result.forEach(student => {
              console.log(student.data());
            });
          }
        );
      });
      afternoonReferences.forEach(reference => {
        db.collection("requests")
        .where("career", "==", reference).where("accepted", "==", 1).get().then(
          result => { 
            result.forEach(student => {
              console.log(student.data());
            });
          }
        );
      }); */
      
      
  },
  mounted() {}
};
</script>

<style>
.v-card__title {
  flex-direction: column;
}

.v-card__title > .v-input {
  width: 100%;
}
</style>